package hw5;

import java.io.ByteArrayOutputStream;
import java.io.PrintStream;
import java.util.Properties;

import junit.framework.TestCase;

public class FormLetterTest extends TestCase {

	public void testAddTextEntry() {
		FormLetter f = new FormLetter("Test");
		String content = "Mary Had A Little Lamb";
		f.addTextEntry(content);
		ByteArrayOutputStream os = new ByteArrayOutputStream();
		PrintStream out = new PrintStream(os);
		f.doFormLetter(null, out);
		
		assertTrue(os.toString().equals(content+"\n"));
	}

	public void testAddDataItemEntry() {
		FormLetter f = new FormLetter("Test");
		String data = "name";
		String value = "Mary Poppins";
		f.addDataItemEntry(data);
		Properties p = new Properties();
		p.setProperty(data, value);
		ByteArrayOutputStream os = new ByteArrayOutputStream();
		PrintStream out = new PrintStream(os);
		f.doFormLetter(p, out);
		assertTrue(os.toString().equals(value+"\n"));
		os.reset();
		f.printFormLetterTemplate(out);
		assertTrue(os.toString().equals("<"+data+">\n"));
	}

	public void testGetTitle() {
		String title = "A form to remember";
		FormLetter f = new FormLetter(title);
		assertTrue(f.getTitle().equals(title));
	}

}
